/**
 * Outside section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoOutside(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preOutside;
    var subController = ctrl.outside;
    var changeController = ctrl.outside;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new SlaveNoonTwoOutsideRefuse(ctrl);
    var secondNext = new SlaveNoonTwoOutsideDrink(ctrl);
    var thirdNext = new SlaveNoonTwoOutsideBathe(ctrl);

    var firstChoice = SlaveNoonTwoOutsideChoice.REFUSE;
    var secondChoice = SlaveNoonTwoOutsideChoice.DRINK;
    var thirdChoice = SlaveNoonTwoOutsideChoice.BATHE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var injected = ctrl.gag.has();
        var neither = ctrl.potion.get() === SlaveNoonTwoGoodPotionChoice.NEITHER;
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var eager = global.kobold.history.shared.enslavement.noonTwo.kissedBallsEager;
        var kissedBalls = global.kobold.history.shared.enslavement.noonTwo.kissedBalls || eager;
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            With your body ${injected ? `forcibly altered` : `${neither ? `left unaltered` : `changed for the better`}`},
                            Fenrir takes hold of the collar around your neck.
                            His [i]slave[/i] in tow, he proudly strides away from the caravan, into town.
                            While not a whole lot of people call the hamlet home, there's still quite a few farmers loitering about.
                            Probably getting some lunch, or just taking a break from work for a bit.
                            Perhaps they've [i]heard[/i] of the [b]slave auction[/b] about to take place.
                            The moment the two of you come into view, all of their eyes instantly shift towards the bandit and his prize.
                        [/p]
                        [p]
                            You can't tell who's drawing more attention: the naked wolf or you yourself.
                            While you'd [b]hoped[/b] that the both of you being nude would somewhat [b]lessen[/b] your shame,
                            it has quite the opposite effect.
                            It's as if the canine is broadcasting his ownership to the entire village,
                            strutting about the fact that
                            ${fucked ? `he fucked you yesterday` : `${kissedBalls ? `you just kissed his nuts` : `he's about to sell you`}`}.
                            ${eager ? `You can't help but admire his dominant attitude.` : `You [b]hate[/b] how he thinks he [b]owns[/b] you.`}
                        [/p]
                        [p]
                            Despite Fenrir catching some of their glares,
                            you can't help but feel the farmers' eyes staring at you, inpecting your body,
                            ${eager ? `envisioning you in every lewd situation imaginable` : `judging you ability to work as their maid,
                            their cook or their farmhand`}.
                            Being [b]paraded[/b] around like this is shameful, to say the least${eager ? `, but also kind of arousing` : ``}.
                            You can't help but wonder what other kind of ${eager ? `alluring` : `degrading`} things the lupine has in store for you.
                        [/p]
                        [p]
                            Walking over to one of the buildings, your captor suddenly comes to a halt.
                            Stepping besides him, you notice he's stopped in front of a wide, long wooden animal drinking trough.
                            You can immediately tell it's been [b]thoroughly[/b] used, [b]very[/b] recently.
                            The water is slightly murky, bits of fur and leaves of chewed grass floating at the surface, alongside a great amount of undiluted [b]spit[/b],
                            so much of the stuff that you're starting to wonder how [i]little[/i] of the liquid left is actual [b]water[/b].
                            But then again, the feral saliva might just be a [i]surface layer[/i] of sorts.
                        [/p]
                        [p]
                            "[color=gblue]Here we are, ${injected ? `slave` : name}.
                            Time to [b]wash up[/b].
                            You need to look presentable.
                            ${fucked ? `Can't have you go on stage with cum splatters on your thighs` : `
                            Can't have you go on stage all dirty from running through the forest the other day`}.[/color]"
                            Stage?
                            Casting your gaze to the crossroads at the center of the hamlet,
                            you notice a small wooden podium built right besides the well.
                            ${eager ? `` : `[i]Oh no[/i].`}
                            They're going to make a [b]big deal[/b] out of this, aren't they?
                        [/p]
                        [p]
                            ${eager ? `` : `You sigh loudly.`}
                            ${injected ? `Your mouth still gagged, you give Fenrir a small nod,
                            followed by an inquisitive gaze.` : `You tell Fenrir that you'll gladly accept the opportunity to wash up.`}
                            Did he bring a tub, or is he going to draw water from the well?
                            "[color=gblue]${injected ? `What are you waiting for?
                            Get in.` : `A tub?
                            You're staring at it, dumbass.`}[/color]"
                            Wait, the trough?
                            He has to be kidding.
                            "[color=gblue]If it's good enough for our pack animals to drink from,
                            then it's also good enough for a kobold like you to clean yourself in.
                            Now get started.
                            There's only a couple of minutes left before the auction's supposed to begin.[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Refuse</button>`;

        var tooltip = global.parser.parse(`You are [b]not[/b] going to wash up in a trough full of [b]slobber[/b].`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 205px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Drink</button>`;

        var tooltip = global.parser.parse(`It may be filthy, but it's the only water you've seen in more than a day.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Bathe</button>`;

        var tooltip = global.parser.parse(`Disgusting or not, you need to be clean if you want to get [i]bought[/i].`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var SlaveNoonTwoOutsideChoice = {
    REFUSE: 1,
    DRINK: 2,
    BATHE: 3
};
