/**
 * Proposition section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoGoodMPlus(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = SlaveNoonTwoGoodPotionChoice.MPLUS;
    var reqController = ctrl.potion;
    var subController = ctrl.preOutside;
    var changeController = ctrl.mPlus;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.outside;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.tookMPlus = true;
        var eager = global.kobold.history.shared.enslavement.noonTwo.kissedBallsEager;
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            You've steered clear of [i]body-altering[/i] drugs so far,
                            partly because you like yourself the way you are,
                            and partly because you've never really had the [i]money[/i] to buy one.
                            Now that an opportunity is presenting itself, however,
                            you can't say you're not a teensy bit [i]interested[/i].
                            You might like your body even [b]better[/b] with a few [i]enhancements[/i].
                            And you doubt you'll ever get a chance like this again.
                        [/p]
                        [p]
                            After a bit of mental deliberation, you gingerly reach out for the [color=blue][b]blue[/b][/color] bottle.
                            ${global.kobold.inventory.createItemWithTooltip(new mPlus(), true)}.
                            This should make you more of a [i]man[/i]${dick ? `` : `, if at the cost of some femininity`}.
                            "[color=gblue]Boy juice, huh? Good choice. Drink up.[/color]"
                        [/p]
                        [p]
                            You've thought about this plenty.
                            Perhaps even considered it once or twice.
                            But you never would have believed that the opportunity would have presented itself so [i]casually[/i].
                            You didn't have to [b]steal[/b] the potion, or [b]beg[/b] Seki for one.
                            While Fenrir may or may not realize it, this [i]present[/i] means a lot more to you than he thinks.
                            Plus you know these concoctions don't come cheap.
                            Maybe he's not that bad of a person after all.
                            Or perhaps he hopes it'll make you [b]sell[/b] for more.
                        [/p]
                        [p]
                            You pop the lid off the potion, and gulp down its contents.
                            The rather watery liquid tastes like blueberries.
                            The moment you swallow the first mouthful, you can already feel the stuff beginning to affect your body.
                        `;
        if (dick) {
            toReturn += `   Your member stirs within your loins, tangibly growing larger,
                            your cockslit becoming a lot more [b]cramped[/b].
                            After a few satisfying seconds, the effects come to an end.`;
        } else {
            toReturn += `   Your breasts tingle and throb, retracting into your chest, visibly growing smaller.
                            Your upper chest feels lighter with every passing second, until finally,
                            after a few satisfying seconds, the effects to an end.`;
        }

        toReturn += `   [/p]
                        [p]
                            [c]
                                [b]You have grown more masculine.[/b]
                            [/c]
                        [/p]
                        [p]
                            "[color=gblue]You look a lot better already.[/color]" comments the wolf.
                            You can't help but [i]blush[/i] a little.
                            You [b]do[/b] look a bit more [i]handsome[/i] than before.
                            And it's all thanks to Fenrir.
                            ${eager ? `You are going to [b]love[/b] being his slave.` : `The two of you may not see eye to eye,
                            but maybe being his [i]slave[/i] won't be so bad after all.
                            Then again, this might have all been a [b]trick[/b] to get you to trust him more.
                            With bandits, you can never know for sure.`}
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
